//+------------------------------------------------------------------+
//|                                                  test_orders.mq5 |
//|                              Copyright 2014, Michael aka Mikalas |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Michael aka Mikalas"
#property link      "http://www.mql5.com"
#property version   "1.00"
//
input double          Price        = 15800;                //
input double          Volume       = 3;                    //
//
ulong    order_ticket;
ulong    exp_magic = 22001133;
datetime order_time;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
  order_time = TimeCurrent(); 
  Print( "   = ", order_time);

  if( !ObjectCreate( 0, "set_button", OBJ_BUTTON, 0, 0, 0 ) )
  {
    MessageBox( " 'Set order  !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
  else
  {
    ObjectSetInteger( 0, "set_button", OBJPROP_CORNER, CORNER_RIGHT_LOWER ); //LEFT
    ObjectSetInteger( 0, "set_button", OBJPROP_XDISTANCE, 70 ); 
    ObjectSetInteger( 0, "set_button", OBJPROP_YDISTANCE, 20 );
    ObjectSetInteger( 0, "set_button", OBJPROP_XSIZE, 70 );
    ObjectSetInteger( 0, "set_button", OBJPROP_YSIZE, 20 );
    ObjectSetInteger( 0, "set_button", OBJPROP_STATE, false );
    ObjectSetString( 0, "set_button", OBJPROP_TEXT, "Set order" );
  }
//---  
  if( !ObjectCreate( 0, "rem_button", OBJ_BUTTON, 0, 0, 0 ) )
  {
    MessageBox( " 'Remove order  !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
  else
  {
    ObjectSetInteger( 0, "rem_button", OBJPROP_CORNER, CORNER_RIGHT_LOWER ); //LEFT
    ObjectSetInteger( 0, "rem_button", OBJPROP_XDISTANCE, 145 );               
    ObjectSetInteger( 0, "rem_button", OBJPROP_YDISTANCE, 20 );
    ObjectSetInteger( 0, "rem_button", OBJPROP_XSIZE, 70 );
    ObjectSetInteger( 0, "rem_button", OBJPROP_YSIZE, 20 );
    ObjectSetInteger( 0, "rem_button", OBJPROP_STATE, false );
    ObjectSetString( 0, "rem_button", OBJPROP_TEXT, "Rem order" );
  }
//---  
  if( !ObjectCreate( 0, "info_button", OBJ_BUTTON, 0, 0, 0 ) )
  {
    MessageBox( " 'info  !", "", MB_OK | MB_ICONHAND );
    return( INIT_FAILED );
  }
  else
  {
    ObjectSetInteger( 0, "info_button", OBJPROP_CORNER, CORNER_RIGHT_LOWER ); //LEFT
    ObjectSetInteger( 0, "info_button", OBJPROP_XDISTANCE, 220 );                
    ObjectSetInteger( 0, "info_button", OBJPROP_YDISTANCE, 20 );
    ObjectSetInteger( 0, "info_button", OBJPROP_XSIZE, 70 );
    ObjectSetInteger( 0, "info_button", OBJPROP_YSIZE, 20 );
    ObjectSetInteger( 0, "info_button", OBJPROP_STATE, false );
    ObjectSetString( 0, "info_button", OBJPROP_TEXT, "Info" );
  }  
  ChartRedraw();
        
  return( INIT_SUCCEEDED );
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit( const int reason )
{
  ObjectDelete( 0, "set_button" );
  ObjectDelete( 0, "rem_button" );
  ObjectDelete( 0, "imfo_button" );
  ChartSetInteger( 0, CHART_COLOR_BACKGROUND, clrBlack );
  ChartRedraw();
}
//+------------------------------------------------------------------+
//| Expert Chart event function                                      |
//+------------------------------------------------------------------+
void OnChartEvent( const int id, const long& lparam, const double& dparam, const string& sparam )
{
  if ( id == CHARTEVENT_OBJECT_CLICK )
  {
    if ( sparam == "set_button" )
    {
      SetOrder( order_ticket );
      ObjectSetInteger( 0, "set_button", OBJPROP_STATE, false );
    }
    else
    if ( sparam == "rem_button" )
    {
      RemoveOrder( order_ticket );
      ObjectSetInteger( 0, "rem_button", OBJPROP_STATE, false );
    }
    else
    if ( sparam == "info_button" )
    {
      GetOrderInfo( order_ticket );
      ObjectSetInteger( 0, "info_button", OBJPROP_STATE, false );
    }
    ChartRedraw();
  }
}
//+------------------------------------------------------------------+
//| Expert Get orders info function                                  |
//+------------------------------------------------------------------+
void GetHistoryOrderData( const ulong ticket )
{
  if ( HistoryOrderSelect( ticket ) )
  {
    Print( "GetHistoryOrderData:    .  = ", ticket );
    long pos_id = long( HistoryOrderGetInteger( ticket, ORDER_POSITION_ID ) );
    
    if ( pos_id > 0 )
    {
      Print( "GetHistoryOrderData: ID  = ", pos_id );
    }
    else
    {
      Print( "GetHistoryOrderData: ID  = 0" );
    }
  }
  else
  {
    Print( "GetHistoryOrderData:    .  = ", ticket );
  }
}
//+------------------------------------------------------------------+
//| Expert Get orders info function                                  |
//+------------------------------------------------------------------+
void GetOrderInfo( const ulong ticket )
{
  if ( ticket > 0 )
  {
    Print( "GetOrderInfo:  = ", ticket );
    
    if ( OrderSelect( ticket ) )
    {
      Print( "GetOrderInfo:    = ", ticket );
      string ord_symbol = OrderGetString( ORDER_SYMBOL );
           
      if ( PositionSelect( ord_symbol ) )
      {
        Print( "GetOrderInfo:  ." );
        long pos_id = OrderGetInteger( ORDER_POSITION_ID );
        Print( "GetOrderInfo: ID  = ", pos_id );
        Print( "GetOrderInfo:  ..." );
        GetHistoryOrderData( ticket );
      }
      else
      {
        Print( "GetOrderInfo:  ." );
        Print( "GetOrderInfo:  ..." );
        GetHistoryOrderData( ticket );
      } 
    }
    else
    {
      Print( "GetOrderInfo:    ,  = ", ticket );
      Print( "GetOrderInfo:  ..." );
      GetHistoryOrderData( ticket );
    }
  }
  else
  {
    Print( "GetOrderInfo:  = 0" );
  }
//---
  Print( "GetOrderInfo:           ..." );
  GetHistoryAllOrders();  
}
//+------------------------------------------------------------------+
//| Expert Get All History orders function                           |
//+------------------------------------------------------------------+
void GetHistoryAllOrders()
{
  datetime cur_time = TimeCurrent();
  
  if ( HistorySelect( order_time, cur_time ) )
  {
    Print( "GetHistoryAllOrders:      ", order_time, "  ", cur_time, " ." );
    
    int orders_total = HistoryOrdersTotal();
    
    if ( orders_total > 0 )
    {
      Print( "GetHistoryAllOrders:     = ", orders_total );
      
      for ( int i = 0; i < orders_total; i++ )
      {
        ulong hist_ticket = HistoryOrderGetTicket( i );
        
        if ( hist_ticket > 0 )
        {
          Print( "GetHistoryAllOrders:    ", i, ";  = ", hist_ticket );
          
          uint pos_id = uint( HistoryOrderGetInteger( hist_ticket, ORDER_POSITION_ID ) );
          
          if ( pos_id > 0 )
          {
            Print( "GetHistoryAllOrders: ORDER_POSITION_ID = ", pos_id, ";  = ", hist_ticket );
          }
          else
          {
            Print( "GetHistoryAllOrders:    ", i, ";  = ", hist_ticket, "; ORDER_POSITION_ID = 0" );
          }
        }   
      }
    }
    else
    {
      Print( "GetHistoryAllOrders:     !" );
    }
  }
  else
  {
    Print( "GetHistoryAllOrders:      ", order_time, "  ", cur_time, "  !" );
  }
}
//+------------------------------------------------------------------+
//| Expert Get retcode function                                      |
//+------------------------------------------------------------------+
string GetRetCode( const uint code )
{
  string retcode;
  
  switch( code )
  {
    case 10004: retcode = "";
         break;
    case 10006: retcode = " ";
         break;
    case 10007: retcode = "  ";
         break;
    case 10008: retcode = " ";
         break;
    case 10009: retcode = " ";
         break;
    case 10010: retcode = "  ";
         break;
    case 10011: retcode = "  ";
         break;
    case 10012: retcode = "    ";
         break;
    case 10013: retcode = " ";
         break;
    case 10014: retcode = "   ";
         break;
    case 10015: retcode = "   ";
         break;
    case 10016: retcode = "   ";
         break;
    case 10017: retcode = " ";
         break;
    case 10018: retcode = " ";
         break;
    case 10019: retcode = "      ";
         break;
    case 10020: retcode = " ";
         break;
    case 10021: retcode = "    ";
         break;
    case 10022: retcode = "     ";
         break;
    case 10023: retcode = "  ";
         break;
    case 10024: retcode = "  ";
         break;
    case 10025: retcode = "   ";
         break;
    case 10026: retcode = "  ";
         break;
    case 10027: retcode = "   ";
         break;
    case 10028: retcode = "   ";
         break;
    case 10029: retcode = "   ";
         break;
    case 10030: retcode = "      ";
         break;
    case 10031: retcode = "    ";
         break;
    case 10032: retcode = "     ";
         break;
    case 10033: retcode = "     ";
         break;
    case 10034: retcode = "         ";
         break;
    case 10035: retcode = "    ";
         break;
    case 10036: retcode = "   POSITION_IDENTIFIER  ";
         break;
    default: retcode = "  !";  
         break; 
  }
  return( retcode );
}
//+------------------------------------------------------------------+
//| Expert set order function                                        |
//+------------------------------------------------------------------+
void SetOrder( ulong &ticket )
{
  MqlTradeRequest request = {0};
  MqlTradeResult  result  = {0};
//---
  ticket = 0;
//  order_time = TimeCurrent();
   
//--- Fill structure
  request.action       = TRADE_ACTION_PENDING;
  request.magic        = exp_magic;
  request.symbol       = _Symbol;
  request.volume       = Volume;
  request.price        = Price;
  request.type         = ORDER_TYPE_SELL_LIMIT;
  request.comment      = " ...";      
  request.type_filling = ORDER_FILLING_RETURN;
  request.type_time    = ORDER_TIME_DAY;
 
//--- Send order
  if ( OrderSend( request, result ) )
  {
    if ( result.retcode == TRADE_RETCODE_PLACED ) 
    {
      ticket = result.order;
    }
  }
  else
  {
    Print( "SetOrder:    ! ", _Symbol, ",   = ", GetRetCode( result.retcode ) );
  }
}
//+------------------------------------------------------------------+
//| Expert remove order function                                     |
//+------------------------------------------------------------------+
void RemoveOrder( ulong &ticket )
{
  if ( ticket > 0 )
  {
    if ( OrderSelect( ticket ) )
    {
      MqlTradeRequest request = {0};
      MqlTradeResult  result  = {0};
            
      request.action = TRADE_ACTION_REMOVE;
      request.order  = ticket;
          
      if ( OrderSend( request, result ) )
      {
        if ( result.retcode == TRADE_RETCODE_PLACED )
        { 
          ticket = result.order;
        }  
      }
      else
      {
        Print( "RemoveOrder:   !  = ", result.order, ";   = ", GetRetCode( result.retcode ) );
      }
    }
    else
    {
      Print( "RemoveOrder:      !  = ", ticket );
    }
  }
  else
  {
    Print( "RemoveOrder:    !  = 0");
  }
}
//+------------------------------------------------------------------+
// Expert Trade Transaction function                                 |
//+------------------------------------------------------------------+
void OnTradeTransaction( const MqlTradeTransaction &trans, const MqlTradeRequest &request, const MqlTradeResult &result )
{
  switch( trans.type )
  {
    case TRADE_TRANSACTION_DEAL_ADD:     if ( ( order_ticket != 0 ) && ( trans.order == order_ticket ) )
                                         {
                                           Print( "OnTradeTransaction:  ,  = ", trans.order ); 
                                         }
                                         break; 
                                           
    case TRADE_TRANSACTION_HISTORY_ADD:  switch( trans.order_state )
                                         {
                                           case ORDER_STATE_CANCELED: 
                                           case ORDER_STATE_REJECTED: 
                                           case ORDER_STATE_EXPIRED:  if ( ( order_ticket != 0 ) && ( trans.order == order_ticket ) )
                                                                      {
                                                                        Print( "OnTradeTransaction:   ,  = ", trans.order ); 
                                                                      }  
                                                                      break; 
                                         } 
                                         break; 
                                         
    case TRADE_TRANSACTION_ORDER_UPDATE: switch( trans.order_state )
                                         {
                                           case ORDER_STATE_PLACED:   if ( ( order_ticket != 0 ) && ( trans.order == order_ticket ) )
                                                                      {
                                                                        Print( "OnTradeTransaction:  ,  = ", trans.order );
                                                                      }
                                                                      break;
                                         }
                                         break;                                                                   
  }                                     
} 
//+------------------------------------------------------------------+
//| The END                                                          |
//+------------------------------------------------------------------+

      